/*	test_String_Vector_Comparator

PIRL CVS ID: test_String_Vector_Comparator.java,v 1.4 2012/04/16 06:04:12 castalia Exp

Test of the String_Vector_Comparator class.

Copyright (C) 2008-2012  Arizona Board of Regents on behalf of the
Planetary Image Research Laboratory, Lunar and Planetary Laboratory at
the University of Arizona.

This file is part of the PIRL Java Packages.

The PIRL Java Packages are free software; you can redistribute them
and/or modify them under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation, either version 3 of
the License, or (at your option) any later version.

The PIRL Java Packages are distributed in the hope that they will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser
General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

*******************************************************************************/

import PIRL.Conductor.String_Vector_Comparator;

import java.util.Vector;
import java.util.Iterator;
import java.util.Collections;


public class test_String_Vector_Comparator
{
public static void main
	(
	String[]	args
	)
{
System.out.println
	("*** test_String_Vector_Comparator\n"
	+ String_Vector_Comparator.ID);

Vector<Vector<Object>>
	sandwiches = new Vector<Vector<Object>> ();
Vector<Object>
	sandwich;

sandwich = new Vector<Object> ();
sandwich.add (new Integer (12));	// Units
sandwich.add ("Ham");			// Meat
sandwich.add ("Provolone");		// Cheese
sandwich.add ("Wheat");			// Bread
sandwich.add (new Float (3.55));	// Price
sandwiches.add (sandwich);
sandwich = new Vector<Object> ();
sandwich.add (new Integer (5));
sandwich.add ("Turkey");
sandwich.add ("Provolone");
sandwich.add ("White");
sandwich.add (new Float (2.00));
sandwiches.add (sandwich);
sandwich = new Vector<Object> ();
sandwich.add (new Integer (76));
sandwich.add ("Bologna");
sandwich.add ("American");
sandwich.add ("White");
sandwich.add (new Float (1.55));
sandwiches.add (sandwich);
sandwich = new Vector<Object> ();
sandwich.add (new Integer (16));
sandwich.add ("Tuna");
sandwich.add ("--");
sandwich.add ("Rye");
sandwich.add (new Float (1.50));
sandwich = new Vector<Object> ();
sandwich.add (new Integer (8));
sandwich.add ("Roast Beef");
sandwich.add ("Provolone");
sandwich.add ("Pumpernickel");
sandwich.add (new Float (5.95));
sandwiches.add (sandwich);
sandwich = new Vector<Object> ();
sandwich.add (new Integer (1));
sandwich.add ("Salami");
sandwich.add ("Gouda");
sandwich.add ("Croissant");
sandwich.add (new Float (5.75));
sandwiches.add (sandwich);

System.out.println ("Original Vector -");
print_table (sandwiches);

String_Vector_Comparator
	test_comparator = new String_Vector_Comparator ();
Collections.sort (sandwiches,test_comparator);
System.out.println ("Sorted on field 0 -");
print_table (sandwiches);

test_comparator.Index (1);
Collections.sort (sandwiches,test_comparator);
System.out.println ("Sorted on field 1 -");
print_table (sandwiches);

test_comparator.Index (2);
Collections.sort (sandwiches,test_comparator);
System.out.println ("Sorted on field 2 -");
print_table (sandwiches);

test_comparator.Index (3);
Collections.sort (sandwiches,test_comparator);
System.out.println ("Sorted on field 3 -");
print_table (sandwiches);

test_comparator.Index (4);
Collections.sort (sandwiches,test_comparator);
System.out.println ("Sorted on field 4 -");
print_table (sandwiches);
}


private static void print_table
	(
	Vector<Vector<Object>> 	table
	)
{
Iterator
	entries = table.iterator ();
while (entries.hasNext ())
	System.out.println (entries.next ());
}

}
